## GMenu GMenu — A simple implementation of GMenuModel |

## Functions

GMenu * | g_menu_new ()
void | g_menu_freeze ()
void | g_menu_insert ()
void | g_menu_prepend ()
void | g_menu_append ()
void | g_menu_insert_item ()
void | g_menu_append_item ()
void | g_menu_prepend_item ()
void | g_menu_insert_section ()
void | g_menu_prepend_section ()
void | g_menu_append_section ()
void | g_menu_append_submenu ()
void | g_menu_insert_submenu ()
void | g_menu_prepend_submenu ()
void | g_menu_remove ()
void | g_menu_remove_all ()
GMenuItem * | g_menu_item_new ()
GMenuItem * | g_menu_item_new_section ()
GMenuItem * | g_menu_item_new_submenu ()
GMenuItem * | g_menu_item_new_from_model ()
void | g_menu_item_set_label ()
void | g_menu_item_set_icon ()
void | g_menu_item_set_action_and_target_value ()
void | g_menu_item_set_action_and_target ()
void | g_menu_item_set_detailed_action ()
void | g_menu_item_set_section ()
void | g_menu_item_set_submenu ()
GVariant * | g_menu_item_get_attribute_value ()
gboolean | g_menu_item_get_attribute ()
GMenuModel * | g_menu_item_get_link ()
void | g_menu_item_set_attribute_value ()
void | g_menu_item_set_attribute ()
void | g_menu_item_set_link ()

## Types and Values

| GMenu
| GMenuItem

## Object Hierarchy

        GObject
        ├── GMenuItem
        ╰── GMenuModel
            ╰── GMenu

## Includes

    #include <gio/gio.h>

## Description

GMenu is a simple implementation of GMenuModel. You populate a GMenu by adding GMenuItem instances to it.

There are some convenience functions to allow you to directly add items (avoiding GMenuItem) for the common cases. To add a regular item, use `g_menu_insert()`. To add a section, use `g_menu_insert_section()`. To add a submenu, use `g_menu_insert_submenu()`.

## Functions

### g_menu_new ()

    GMenu *
    g_menu_new (void);

Creates a new GMenu.

The new menu has no items.

#### Returns

a new GMenu

Since: 2.32

### g_menu_freeze ()

    void
    g_menu_freeze (GMenu *menu);

Marks `menu` as frozen.

After the menu is frozen, it is an error to attempt to make any changes to it. In effect this means that the GMenu API must no longer be used.

This function causes `g_menu_model_is_mutable()` to begin returning `FALSE`, which has some positive performance implications.

#### Parameters

menu | a GMenu |

Since: 2.32

### g_menu_insert ()

    void
    g_menu_insert (GMenu *menu,
                   gint position,
                   const gchar *label,
                   const gchar *detailed_action);

Convenience function for inserting a normal menu item into `menu` . Combine `g_menu_item_new()` and `g_menu_insert_item()` for a more flexible alternative.

#### Parameters

menu | a GMenu |
position | the position at which to insert the item |
label | the section label, or `NULL`. | [nullable]
detailed_action | the detailed action string, or `NULL`. | [nullable]

Since: 2.32

### g_menu_prepend ()

    void
    g_menu_prepend (GMenu *menu,
                    const gchar *label,
                    const gchar *detailed_action);

Convenience function for prepending a normal menu item to the start of `menu` . Combine `g_menu_item_new()` and `g_menu_insert_item()` for a more flexible alternative.

#### Parameters

menu | a GMenu |
label | the section label, or `NULL`. | [nullable]
detailed_action | the detailed action string, or `NULL`. | [nullable]

Since: 2.32

### g_menu_append ()

    void
    g_menu_append (GMenu *menu,
                   const gchar *label,
                   const gchar *detailed_action);

Convenience function for appending a normal menu item to the end of `menu` . Combine `g_menu_item_new()` and `g_menu_insert_item()` for a more flexible alternative.

#### Parameters

menu | a GMenu |
label | the section label, or `NULL`. | [nullable]
detailed_action | the detailed action string, or `NULL`. | [nullable]

Since: 2.32

### g_menu_insert_item ()

    void
    g_menu_insert_item (GMenu *menu,
                        gint position,
                        GMenuItem *item);

Inserts `item` into `menu` .

The "insertion" is actually done by copying all of the attribute and link values of `item` and using them to form a new item within `menu` . As such, `item` itself is not really inserted, but rather, a menu item that is exactly the same as the one presently described by `item` .

This means that `item` is essentially useless after the insertion occurs. Any changes you make to it are ignored unless it is inserted again (at which point its updated values will be copied).

You should probably just free `item` once you're done.

There are many convenience functions to take care of common cases. See `g_menu_insert()`, `g_menu_insert_section()` and `g_menu_insert_submenu()` as well as "prepend" and "append" variants of each of these functions.

#### Parameters

menu | a GMenu |
position | the position at which to insert the item |
item | the GMenuItem to insert |

Since: 2.32

### g_menu_append_item ()

    void
    g_menu_append_item (GMenu *menu,
                        GMenuItem *item);

Appends `item` to the end of `menu` .

See `g_menu_insert_item()` for more information.

#### Parameters

menu | a GMenu |
item | a GMenuItem to append |

Since: 2.32

### g_menu_prepend_item ()

    void
    g_menu_prepend_item (GMenu *menu,
                         GMenuItem *item);

Prepends `item` to the start of `menu` .

See `g_menu_insert_item()` for more information.

#### Parameters

menu | a GMenu |
item | a GMenuItem to prepend |

Since: 2.32

### g_menu_insert_section ()

    void
    g_menu_insert_section (GMenu *menu,
                           gint position,
                           const gchar *label,
                           GMenuModel *section);

Convenience function for inserting a section menu item into `menu` . Combine `g_menu_item_new_section()` and `g_menu_insert_item()` for a more flexible alternative.

#### Parameters

menu | a GMenu |
position | the position at which to insert the item |
label | the section label, or `NULL`. | [nullable]
section | a GMenuModel with the items of the section |

Since: 2.32

### g_menu_prepend_section ()

    void
    g_menu_prepend_section (GMenu *menu,
                            const gchar *label,
                            GMenuModel *section);

Convenience function for prepending a section menu item to the start of `menu` . Combine `g_menu_item_new_section()` and `g_menu_insert_item()` for a more flexible alternative.

#### Parameters

menu | a GMenu |
label | the section label, or `NULL`. | [nullable]
section | a GMenuModel with the items of the section |

Since: 2.32

### g_menu_append_section ()

    void
    g_menu_append_section (GMenu *menu,
                           const gchar *label,
                           GMenuModel *section);

Convenience function for appending a section menu item to the end of `menu` . Combine `g_menu_item_new_section()` and `g_menu_insert_item()` for a more flexible alternative.

#### Parameters

menu | a GMenu |
label | the section label, or `NULL`. | [nullable]
section | a GMenuModel with the items of the section |

Since: 2.32

### g_menu_append_submenu ()

    void
    g_menu_append_submenu (GMenu *menu,
                           const gchar *label,
                           GMenuModel *submenu);

Convenience function for appending a submenu menu item to the end of `menu` . Combine `g_menu_item_new_submenu()` and `g_menu_insert_item()` for a more flexible alternative.

#### Parameters

menu | a GMenu |
label | the section label, or `NULL`. | [nullable]
submenu | a GMenuModel with the items of the submenu |

Since: 2.32

### g_menu_insert_submenu ()

    void
    g_menu_insert_submenu (GMenu *menu,
                           gint position,
                           const gchar *label,
                           GMenuModel *submenu);

Convenience function for inserting a submenu menu item into `menu` . Combine `g_menu_item_new_submenu()` and `g_menu_insert_item()` for a more flexible alternative.

#### Parameters

menu | a GMenu |
position | the position at which to insert the item |
label | the section label, or `NULL`. | [nullable]
submenu | a GMenuModel with the items of the submenu |

Since: 2.32

### g_menu_prepend_submenu ()

    void
    g_menu_prepend_submenu (GMenu *menu,
                            const gchar *label,
                            GMenuModel *submenu);

Convenience function for prepending a submenu menu item to the start of `menu` . Combine `g_menu_item_new_submenu()` and `g_menu_insert_item()` for a more flexible alternative.

#### Parameters

menu | a GMenu |
label | the section label, or `NULL`. | [nullable]
submenu | a GMenuModel with the items of the submenu |

Since: 2.32

### g_menu_remove ()

    void
    g_menu_remove (GMenu *menu,
                   gint position);

Removes an item from the menu.

`position` gives the index of the item to remove.

It is an error if position is not in range the range from 0 to one less than the number of items in the menu.

It is not possible to remove items by identity since items are added to the menu simply by copying their links and attributes (ie: identity of the item itself is not preserved).

#### Parameters

menu | a GMenu |
position | the position of the item to remove |

Since: 2.32

### g_menu_remove_all ()

    void
    g_menu_remove_all (GMenu *menu);

Removes all items in the menu.

#### Parameters

menu | a GMenu |

Since: 2.38

### g_menu_item_new ()

    GMenuItem *
    g_menu_item_new (const gchar *label,
                     const gchar *detailed_action);

Creates a new GMenuItem.

If `label` is non-`NULL` it is used to set the "label" attribute of the new item.

If `detailed_action` is non-`NULL` it is used to set the "action" and possibly the "target" attribute of the new item. See `g_menu_item_set_detailed_action()` for more information.

#### Parameters

label | the section label, or `NULL`. | [nullable]
detailed_action | the detailed action string, or `NULL`. | [nullable]

#### Returns

a new GMenuItem

Since: 2.32

### g_menu_item_new_section ()

    GMenuItem *
    g_menu_item_new_section (const gchar *label,
                             GMenuModel *section);

Creates a new GMenuItem representing a section.

This is a convenience API around `g_menu_item_new()` and `g_menu_item_set_section()`.

The effect of having one menu appear as a section of another is exactly as it sounds: the items from `section` become a direct part of the menu that `menu_item` is added to.

Visual separation is typically displayed between two non-empty sections. If `label` is non-`NULL` then it will be encorporated into this visual indication. This allows for labeled subsections of a menu.

As a simple example, consider a typical "Edit" menu from a simple program. It probably contains an "Undo" and "Redo" item, followed by a separator, followed by "Cut", "Copy" and "Paste".

This would be accomplished by creating three GMenu instances. The first would be populated with the "Undo" and "Redo" items, and the second with the "Cut", "Copy" and "Paste" items. The first and second menus would then be added as submenus of the third. In XML format, this would look something like the following:

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    <menu id='edit-menu'>
      <section>
        <item label='Undo'/>
        <item label='Redo'/>
      </section>
      <section>
        <item label='Cut'/>
        <item label='Copy'/>
        <item label='Paste'/>
      </section>
    </menu>

The following example is exactly equivalent. It is more illustrative of the exact relationship between the menus and items (keeping in mind that the 'link' element defines a new menu that is linked to the containing one). The style of the second example is more verbose and difficult to read (and therefore not recommended except for the purpose of understanding what is really going on).

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    <menu id='edit-menu'>
      <item>
        <link name='section'>
          <item label='Undo'/>
          <item label='Redo'/>
        </link>
      </item>
      <item>
        <link name='section'>
          <item label='Cut'/>
          <item label='Copy'/>
          <item label='Paste'/>
        </link>
      </item>
    </menu>

#### Parameters

label | the section label, or `NULL`. | [nullable]
section | a GMenuModel with the items of the section |

#### Returns

a new GMenuItem

Since: 2.32

### g_menu_item_new_submenu ()

    GMenuItem *
    g_menu_item_new_submenu (const gchar *label,
                             GMenuModel *submenu);

Creates a new GMenuItem representing a submenu.

This is a convenience API around `g_menu_item_new()` and `g_menu_item_set_submenu()`.

#### Parameters

label | the section label, or `NULL`. | [nullable]
submenu | a GMenuModel with the items of the submenu |

#### Returns

a new GMenuItem

Since: 2.32

### g_menu_item_new_from_model ()

    GMenuItem *
    g_menu_item_new_from_model (GMenuModel *model,
                                gint item_index);

Creates a GMenuItem as an exact copy of an existing menu item in a GMenuModel.

`item_index` must be valid (ie: be sure to call `g_menu_model_get_n_items()` first).

#### Parameters

model | a GMenuModel |
item_index | the index of an item in `model` |

#### Returns

a new GMenuItem.

Since: 2.34

### g_menu_item_set_label ()

    void
    g_menu_item_set_label (GMenuItem *menu_item,
                           const gchar *label);

Sets or unsets the "label" attribute of `menu_item` .

If `label` is non-`NULL` it is used as the label for the menu item. If it is `NULL` then the label attribute is unset.

#### Parameters

menu_item | a GMenuItem |
label | the label to set, or `NULL` to unset. | [nullable]

Since: 2.32

### g_menu_item_set_icon ()

    void
    g_menu_item_set_icon (GMenuItem *menu_item,
                          GIcon *icon);

Sets (or unsets) the icon on `menu_item` .

This call is the same as calling `g_icon_serialize()` and using the result as the value to `g_menu_item_set_attribute_value()` for `G_MENU_ATTRIBUTE_ICON`.

This API is only intended for use with "noun" menu items; things like bookmarks or applications in an "Open With" menu. Don't use it on menu items corresponding to verbs (eg: stock icons for 'Save' or 'Quit').

If `icon` is `NULL` then the icon is unset.

#### Parameters

menu_item | a GMenuItem |
icon | a GIcon, or `NULL` |

Since: 2.38

### g_menu_item_set_action_and_target_value ()

    void
    g_menu_item_set_action_and_target_value
                                   (GMenuItem *menu_item,
                                    const gchar *action,
                                    GVariant *target_value);

Sets or unsets the "action" and "target" attributes of `menu_item` .

If `action` is `NULL` then both the "action" and "target" attributes are unset (and `target_value` is ignored).

If `action` is non-`NULL` then the "action" attribute is set. The "target" attribute is then set to the value of `target_value` if it is non-`NULL` or unset otherwise.

Normal menu items (ie: not submenu, section or other custom item types) are expected to have the "action" attribute set to identify the action that they are associated with. The state type of the action help to determine the disposition of the menu item. See GAction and GActionGroup for an overview of actions.

In general, clicking on the menu item will result in activation of the named action with the "target" attribute given as the parameter to the action invocation. If the "target" attribute is not set then the action is invoked with no parameter.

If the action has no state then the menu item is usually drawn as a plain menu item (ie: with no additional decoration).

If the action has a boolean state then the menu item is usually drawn as a toggle menu item (ie: with a checkmark or equivalent indication). The item should be marked as 'toggled' or 'checked' when the boolean state is `TRUE`.

If the action has a string state then the menu item is usually drawn as a radio menu item (ie: with a radio bullet or equivalent indication). The item should be marked as 'selected' when the string state is equal to the value of the `target` property.

See `g_menu_item_set_action_and_target()` or `g_menu_item_set_detailed_action()` for two equivalent calls that are probably more convenient for most uses.

#### Parameters

menu_item | a GMenuItem |
action | the name of the action for this item. | [nullable]
target_value | a GVariant to use as the action target. | [nullable]

Since: 2.32

### g_menu_item_set_action_and_target ()

    void
    g_menu_item_set_action_and_target (GMenuItem *menu_item,
                                       const gchar *action,
                                       const gchar *format_string,
                                       ...);

Sets or unsets the "action" and "target" attributes of `menu_item` .

If `action` is `NULL` then both the "action" and "target" attributes are unset (and `format_string` is ignored along with the positional parameters).

If `action` is non-`NULL` then the "action" attribute is set. `format_string` is then inspected. If it is non-`NULL` then the proper position parameters are collected to create a GVariant instance to use as the target value. If it is `NULL` then the positional parameters are ignored and the "target" attribute is unset.

See also `g_menu_item_set_action_and_target_value()` for an equivalent call that directly accepts a GVariant. See `g_menu_item_set_detailed_action()` for a more convenient version that works with string-typed targets.

See also `g_menu_item_set_action_and_target_value()` for a description of the semantics of the action and target attributes.

#### Parameters

menu_item | a GMenuItem |
action | the name of the action for this item. | [nullable]
format_string | a GVariant format string. | [nullable]
... | positional parameters, as per `format_string` |

Since: 2.32

### g_menu_item_set_detailed_action ()

    void
    g_menu_item_set_detailed_action (GMenuItem *menu_item,
                                     const gchar *detailed_action);

Sets the "action" and possibly the "target" attribute of `menu_item` .

The format of `detailed_action` is the same format parsed by `g_action_parse_detailed_name()`.

See `g_menu_item_set_action_and_target()` or `g_menu_item_set_action_and_target_value()` for more flexible (but slightly less convenient) alternatives.

See also `g_menu_item_set_action_and_target_value()` for a description of the semantics of the action and target attributes.

#### Parameters

menu_item | a GMenuItem |
detailed_action | the "detailed" action string |

Since: 2.32

### g_menu_item_set_section ()

    void
    g_menu_item_set_section (GMenuItem *menu_item,
                             GMenuModel *section);

Sets or unsets the "section" link of `menu_item` to `section` .

The effect of having one menu appear as a section of another is exactly as it sounds: the items from `section` become a direct part of the menu that `menu_item` is added to. See `g_menu_item_new_section()` for more information about what it means for a menu item to be a section.

#### Parameters

menu_item | a GMenuItem |
section | a GMenuModel, or `NULL`. | [nullable]

Since: 2.32

### g_menu_item_set_submenu ()

    void
    g_menu_item_set_submenu (GMenuItem *menu_item,
                             GMenuModel *submenu);

Sets or unsets the "submenu" link of `menu_item` to `submenu` .

If `submenu` is non-`NULL`, it is linked to. If it is `NULL` then the link is unset.

The effect of having one menu appear as a submenu of another is exactly as it sounds.

#### Parameters

menu_item | a GMenuItem |
submenu | a GMenuModel, or `NULL`. | [nullable]

Since: 2.32

### g_menu_item_get_attribute_value ()

    GVariant *
    g_menu_item_get_attribute_value (GMenuItem *menu_item,
                                     const gchar *attribute,
                                     const GVariantType *expected_type);

Queries the named `attribute` on `menu_item` .

If `expected_type` is specified and the attribute does not have this type, `NULL` is returned. `NULL` is also returned if the attribute simply does not exist.

#### Parameters

menu_item | a GMenuItem |
attribute | the attribute name to query |
expected_type | the expected type of the attribute. | [nullable]

#### Returns

the attribute value, or `NULL`.

[nullable][transfer full]

Since: 2.34

### g_menu_item_get_attribute ()

    gboolean
    g_menu_item_get_attribute (GMenuItem *menu_item,
                               const gchar *attribute,
                               const gchar *format_string,
                               ...);

Queries the named `attribute` on `menu_item` .

If the attribute exists and matches the GVariantType corresponding to `format_string` then `format_string` is used to deconstruct the value into the positional parameters and `TRUE` is returned.

If the attribute does not exist, or it does exist but has the wrong type, then the positional parameters are ignored and `FALSE` is returned.

#### Parameters

menu_item | a GMenuItem |
attribute | the attribute name to query |
format_string | a GVariant format string |
... | positional parameters, as per `format_string` |

#### Returns

`TRUE` if the named attribute was found with the expected type

Since: 2.34

### g_menu_item_get_link ()

    GMenuModel *
    g_menu_item_get_link (GMenuItem *menu_item,
                          const gchar *link);

Queries the named `link` on `menu_item` .

#### Parameters

menu_item | a GMenuItem |
link | the link name to query |

#### Returns

the link, or `NULL`.

[nullable][transfer full]

Since: 2.34

### g_menu_item_set_attribute_value ()

    void
    g_menu_item_set_attribute_value (GMenuItem *menu_item,
                                     const gchar *attribute,
                                     GVariant *value);

Sets or unsets an attribute on `menu_item` .

The attribute to set or unset is specified by `attribute` . This can be one of the standard attribute names `G_MENU_ATTRIBUTE_LABEL`, `G_MENU_ATTRIBUTE_ACTION`, `G_MENU_ATTRIBUTE_TARGET`, or a custom attribute name. Attribute names are restricted to lowercase characters, numbers and '-'. Furthermore, the names must begin with a lowercase character, must not end with a '-', and must not contain consecutive dashes.

must consist only of lowercase ASCII characters, digits and '-'.

If `value` is non-`NULL` then it is used as the new value for the attribute. If `value` is `NULL` then the attribute is unset. If the `value` GVariant is floating, it is consumed.

See also `g_menu_item_set_attribute()` for a more convenient way to do the same.

#### Parameters

menu_item | a GMenuItem |
attribute | the attribute to set |
value | a GVariant to use as the value, or `NULL`. | [nullable]

Since: 2.32

### g_menu_item_set_attribute ()

    void
    g_menu_item_set_attribute (GMenuItem *menu_item,
                               const gchar *attribute,
                               const gchar *format_string,
                               ...);

Sets or unsets an attribute on `menu_item` .

The attribute to set or unset is specified by `attribute` . This can be one of the standard attribute names `G_MENU_ATTRIBUTE_LABEL`, `G_MENU_ATTRIBUTE_ACTION`, `G_MENU_ATTRIBUTE_TARGET`, or a custom attribute name. Attribute names are restricted to lowercase characters, numbers and '-'. Furthermore, the names must begin with a lowercase character, must not end with a '-', and must not contain consecutive dashes.

If `format_string` is non-`NULL` then the proper position parameters are collected to create a GVariant instance to use as the attribute value. If it is `NULL` then the positional parameterrs are ignored and the named attribute is unset.

See also `g_menu_item_set_attribute_value()` for an equivalent call that directly accepts a GVariant.

#### Parameters

menu_item | a GMenuItem |
attribute | the attribute to set |
format_string | a GVariant format string, or `NULL`. | [nullable]
... | positional parameters, as per `format_string` |

Since: 2.32

### g_menu_item_set_link ()

    void
    g_menu_item_set_link (GMenuItem *menu_item,
                          const gchar *link,
                          GMenuModel *model);

Creates a link from `menu_item` to `model` if non-`NULL`, or unsets it.

Links are used to establish a relationship between a particular menu item and another menu. For example, `G_MENU_LINK_SUBMENU` is used to associate a submenu with a particular menu item, and `G_MENU_LINK_SECTION` is used to create a section. Other types of link can be used, but there is no guarantee that clients will be able to make sense of them. Link types are restricted to lowercase characters, numbers and '-'. Furthermore, the names must begin with a lowercase character, must not end with a '-', and must not contain consecutive dashes.

#### Parameters

menu_item | a GMenuItem |
link | type of link to establish or unset |
model | the GMenuModel to link to (or `NULL` to unset). | [nullable]

Since: 2.32

## Types and Values

### GMenu

    typedef struct _GMenu GMenu;

GMenu is an opaque structure type. You must access it using the functions below.

Since: 2.32

### GMenuItem

    typedef struct _GMenuItem GMenuItem;

GMenuItem is an opaque structure type. You must access it using the functions below.

Since: 2.32